## jackd2 1.9.10+20150825git1ed50c92~dfsg

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8
from __future__ import print_function

import os
import subprocess
g_maxlen = 40
import shutil
import re
import sys

from waflib import Logs, Options, Task, Utils
from waflib.Build import BuildContext, CleanContext, InstallContext, UninstallContext

VERSION='1.9.11'
APPNAME='jack'
JACK_API_VERSION = '0.1.0'

# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

# lib32 variant name used when building in mixed mode
lib32 = 'lib32'

auto_options = []

def display_msg(msg, status = None, color = None):
    sr = msg
    global g_maxlen
    g_maxlen = max(g_maxlen, len(msg))
    if status:
        Logs.pprint('NORMAL', "%s :" % msg.ljust(g_maxlen), sep=' ')
        Logs.pprint(color, status)
    else:
        print("%s" % msg.ljust(g_maxlen))

def display_feature(msg, build):
    if build:
        display_msg(msg, "yes", 'GREEN')
    else:
        display_msg(msg, "no", 'YELLOW')

# This function prints an error without stopping waf. The reason waf should not
# be stopped is to be able to list all missing dependencies in one chunk.
def print_error(msg):
    print(Logs.colors.RED + msg + Logs.colors.NORMAL)

class AutoOption:
    """
    This class is the foundation for the auto options. It adds an option
    --foo=no|yes to the list of options and deals with all logic and checks for
    these options.

    Each option can have different dependencies that will be checked. If all
    dependencies are available and the user has not done any request the option
    will be enabled. If the user has requested to enable the option the class
    ensures that all dependencies are available and prints an error message
    otherwise. If the user disables the option, i.e. --foo=no, no checks are
    made.

    For each option it is possible to add packages that are required for the
    option using the add_package function. For dependency programs add_program
    should be used. For libraries (without pkg-config support) the add_library
    function should be used. For headers the add_header function exists. If
    there is another type of requirement or dependency the check hook (an
    external function called when configuring) can be used.

    When all checks have been made and the class has made a decision the result
    is saved in conf.env['NAME'] where 'NAME' by default is the uppercase of the
    name argument to __init__, but it can be changed with the conf_dest argument
    to __init__.

    The class will define a preprocessor symbol with the result. The default
    name is HAVE_NAME, but it can be changed using the define argument to
    __init__.
    """

    def __init__(self, opt, name, help, conf_dest=None, define=None):
        # check hook to call upon configuration
        self.check_hook = None
        self.check_hook_error = None
        self.check_hook_found = True

        # required libraries
        self.libs = [] # elements on the form [lib,uselib_store]
        self.libs_not_found = [] # elements on the form lib

        # required headers
        self.headers = []
        self.headers_not_found = []

        # required packages (checked with pkg-config)
        self.packages = [] # elements on the form [package,uselib_store,atleast_version]
        self.packages_not_found = [] # elements on the form [package,atleast_version]

        # required programs
        self.programs = [] # elements on the form [program,var]
        self.programs_not_found = [] # elements on the form program

        # the result of the configuration (should the option be enabled or not?)
        self.result = False

        self.help = help
        self.option = '--' + name
        self.dest = 'auto_option_' + name
        if conf_dest:
            self.conf_dest = conf_dest
        else:
            self.conf_dest = name.upper()
        if not define:
            self.define = 'HAVE_' + name.upper()
        else:
            self.define = define
        opt.add_option(self.option, type='string', default='auto', dest=self.dest, help=self.help+' (enabled by default if possible)', metavar='no|yes')

    def add_library(self, library, uselib_store=None):
        """
        Add a required library that should be checked during configuration. The
        library will be checked using the conf.check_cc function. If the
        uselib_store arugment is not given it defaults to LIBRARY (the uppercase
        of the library argument). The uselib_store argument will be passed to
        check_cc which means LIB_LIBRARY, CFLAGS_LIBRARY and DEFINES_LIBRARY,
        etc. will be defined if the option is enabled.
        """
        if not uselib_store:
            uselib_store = library.upper().replace('-', '_')
        self.libs.append([library, uselib_store])

    def add_header(self, header):
        """
        Add a required header that should be checked during configuration. The
        header will be checked using the conf.check_cc function which means
        HAVE_HEADER_H will be defined if found.
        """
        self.headers.append(header)

    def add_package(self, package, uselib_store=None, atleast_version=None):
        """
        Add a required package that should be checked using pkg-config during
        configuration. The package will be checked using the conf.check_cfg
        function and the uselib_store and atleast_version will be passed to
        check_cfg. If uselib_store is None it defaults to PACKAGE (uppercase of
        the package argument) with hyphens and dots replaced with underscores.
        If atleast_version is None it defaults to '0'.
        """
        if not uselib_store:
            uselib_store = package.upper().replace('-', '_').replace('.', '_')
        if not atleast_version:
            atleast_version = '0'
        self.packages.append([package, uselib_store, atleast_version])

    def add_program(self, program, var=None):
        """
        Add a required program that should be checked during configuration. If
        var is not given it defaults to PROGRAM (the uppercase of the program
        argument). If the option is enabled the program is saved as a list (?!)
        in conf.env['PROGRAM'].
        """
        if not var:
            var = program.upper().replace('-', '_')
        self.programs.append([program, var])

    def set_check_hook(self, check_hook, check_hook_error):
        """
        Set the check hook and the corresponding error printing function to the
        configure step. The check_hook argument is a function that should return
        True if the extra prerequisites were found and False if not. The
        check_hook_error argument is an error printing function that should
        print an error message telling the user that --foo was explicitly
        requested but cannot be built since the extra prerequisites were not
        found. Both function should take a single argument that is the waf
        configuration context.
        """
        self.check_hook = check_hook
        self.check_hook_error = check_hook_error

    def _check(self, conf):
        """
        This is an internal function that runs all necessary configure checks.
        It checks all dependencies (even if some dependency was not found) so
        that the user can install all missing dependencies in one go, instead
        of playing the infamous hit-configure-hit-configure game.

        This function returns True if all dependencies were found and False if
        not.
        """
        all_found = True

        # check for libraries
        for lib,uselib_store in self.libs:
            try:
                conf.check_cc(lib=lib, uselib_store=uselib_store)
            except conf.errors.ConfigurationError:
                all_found = False
                self.libs_not_found.append(lib)

        # check for headers
        for header in self.headers:
            try:
                conf.check_cc(header_name=header)
            except conf.errors.ConfigurationError:
                all_found = False
                self.headers_not_found.append(header)

        # check for packages
        for package,uselib_store,atleast_version in self.packages:
            try:
                conf.check_cfg(package=package, uselib_store=uselib_store, atleast_version=atleast_version, args='--cflags --libs')
            except conf.errors.ConfigurationError:
                all_found = False
                self.packages_not_found.append([package,atleast_version])

        # check for programs
        for program,var in self.programs:
            try:
                conf.find_program(program, var=var)
            except conf.errors.ConfigurationError:
                all_found = False
                self.programs_not_found.append(program)

        # call hook (if specified)
        if self.check_hook:
            self.check_hook_found = self.check_hook(conf)
            if not self.check_hook_found:
                all_found = False

        return all_found

    def _configure_error(self, conf):
        """
        This is an internal function that prints errors for each missing
        dependency. The error messages tell the user that this option required
        some dependency, but it cannot be found.
        """

        for lib in self.libs_not_found:
            print_error('%s requires the %s library, but it cannot be found.' % (self.option, lib))

        for header in self.headers_not_found:
            print_error('%s requires the %s header, but it cannot be found.' % (self.option, header))

        for package,atleast_version in self.packages_not_found:
            string = package
            if atleast_version:
                string += ' >= ' + atleast_version
            print_error('%s requires the package %s, but it cannot be found.' % (self.option, string))

        for program in self.programs_not_found:
            print_error('%s requires the %s program, but it cannot be found.' % (self.option, program))

        if not self.check_hook_found:
            self.check_hook_error(conf)

    def configure(self, conf):
        """
        This function configures the option examining the argument given too
        --foo (where foo is this option). This function sets self.result to the
        result of the configuration; True if the option should be enabled or
        False if not. If not all dependencies were found self.result will shall
        be False. conf.env['NAME'] will be set to the same value aswell as a
        preprocessor symbol will be defined according to the result.

        If --foo[=yes] was given, but some dependency was not found an error
        message is printed (foreach missing dependency).

        This function returns True on success and False on error.
        """
        argument = getattr(Options.options, self.dest)
        if argument == 'no':
            self.result = False
            retvalue = True
        elif argument == 'yes':
            if self._check(conf):
                self.result = True
                retvalue = True
            else:
                self.result = False
                retvalue = False
                self._configure_error(conf)
        elif argument == 'auto':
            self.result = self._check(conf)
            retvalue = True
        else:
            print_error('Invalid argument "' + argument + '" to ' + self.option)
            self.result = False
            retvalue = False

        conf.env[self.conf_dest] = self.result
        if self.result:
            conf.define(self.define, 1)
        else:
            conf.define(self.define, 0)
        return retvalue

    def display_message(self):
        """
        This function displays a result message with the help text and the
        result of the configuration.
        """
        display_feature(self.help, self.result)

# This function adds an option to the list of auto options and returns the newly
# created option.

=== example-clients/wscript ===
#! /usr/bin/env python
# encoding: utf-8

example_programs = {
    'jack_freewheel' : 'freewheel.c',
    'jack_connect' : 'connect.c',
    'jack_lsp' : 'lsp.c',
    'jack_metro' : 'metro.c',
    'jack_midiseq' : 'midiseq.c',
    'jack_midisine' : 'midisine.c',
    'jack_showtime' : 'showtime.c',
    'jack_simple_client' : 'simple_client.c',
    'jack_zombie' : 'zombie.c',
    'jack_load' : 'ipload.c',
    'jack_unload' : 'ipunload.c',
    'jack_alias' : 'alias.c',
    'jack_bufsize' : 'bufsize.c',
    'jack_wait' : 'wait.c',
    'jack_samplerate' : 'samplerate.c',
    'jack_evmon' : 'evmon.c',
    'jack_monitor_client' : 'monitor_client.c',
    'jack_thru' : 'thru_client.c',
    'jack_cpu_load' : 'cpu_load.c',
    'jack_simple_session_client' : 'simple_session_client.c',
    'jack_session_notify' : 'session_notify.c',
    'jack_server_control' : 'server_control.cpp',
    'jack_net_slave' : 'netslave.c',
    'jack_net_master' : 'netmaster.c',
    'jack_latent_client' : 'latent_client.c',
    'jack_midi_dump' : 'midi_dump.c',
    'jack_midi_latency_test' : 'midi_latency_test.c'
    }

example_libs = {
    'inprocess' : 'inprocess.c',
    }

def configure(conf):
    conf.env['BUILD_EXAMPLE_CLIENT_TRANSPORT'] = conf.env['READLINE']

    conf.env['BUILD_EXAMPLE_CLIENT_REC'] = conf.env['SNDFILE']

    conf.env['BUILD_EXAMPLE_ALSA_IO'] = conf.env['SAMPLERATE'] and conf.env['BUILD_DRIVER_ALSA']

def build(bld):
    if bld.env['IS_LINUX']:
        os_incdir = ['../linux', '../posix']
    if bld.env['IS_MACOSX']:
        os_incdir = ['../macosx', '../posix']
    if bld.env['IS_SUN']:
        os_incdir = ['../solaris', '../posix']
    if bld.env['IS_WINDOWS']:
        os_incdir = ['../windows']
    for example_program, example_program_source in list(example_programs.items()):
        if example_program == 'jack_server_control':
            use = ['serverlib', 'STDC++']
        elif example_program == 'jack_net_slave':
            if not bld.env['BUILD_NETLIB']:
                continue
            use = ['netlib']
        elif example_program == 'jack_net_master':
            if not bld.env['BUILD_NETLIB']:
                continue
            use = ['netlib']
        else:
            use = ['clientlib']

        prog = bld(features='c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = example_program_source
        prog.use = use
        if bld.env['IS_MACOSX']:
            prog.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc -arch x86_64")
            #prog.env.append_value("LINKFLAGS", "-arch i386 -arch ppc -arch x86_64")
            prog.env.append_value("LINKFLAGS", "")
        if bld.env['IS_LINUX']:
            prog.use += ['RT', 'M']
        if bld.env['IS_SUN']:
            prog.use += ['M']

        prog.target = example_program
   
    if bld.env['BUILD_EXAMPLE_CLIENT_TRANSPORT']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = 'transport.c'
        prog.use = ['clientlib']
        if bld.env['IS_MACOSX']:
            prog.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc -arch x86_64")
            #prog.env.append_value("LINKFLAGS", "-arch i386 -arch ppc -arch x86_64")
            prog.env.append_value("LINKFLAGS", "")
        if bld.env['IS_LINUX']:
            prog.use += ['RT', 'READLINE']
        if bld.env['IS_MACOSX']:
            prog.use += ['READLINE']
        if bld.env['IS_WINDOWS']:
            prog.use += ['READLINE']
        prog.target = 'jack_transport'

    if bld.env['BUILD_EXAMPLE_CLIENT_REC']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = 'capture_client.c'
        prog.use = ['clientlib']
        if bld.env['IS_MACOSX']:
            prog.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc -arch x86_64")
            #prog.env.append_value("LINKFLAGS", "-arch i386 -arch ppc -arch x86_64")
            prog.env.append_value("LINKFLAGS", "")
            prog.use += ['SNDFILE']
        if bld.env['IS_LINUX']:
            prog.use += ['RT', 'SNDFILE']
        if bld.env['IS_SUN']:
            prog.use += ['RT', 'SNDFILE']
        if bld.env['IS_WINDOWS']:
            prog.uselib = ['SNDFILE']
        prog.target = 'jack_rec'

    if bld.env['IS_LINUX'] or bld.env['IS_MACOSX']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['.', '..', '../common/jack', '../common']
        prog.source = ['netsource.c', '../common/netjack_packet.c']
        prog.env.append_value("CFLAGS", "-DNO_JACK_ERROR")
        prog.use = ['CELT', 'SAMPLERATE', 'OPUS', 'M', 'clientlib']
        prog.target = 'jack_netsource'
        prog.defines = ['HAVE_CONFIG_H']

    if bld.env['IS_LINUX'] and bld.env['BUILD_EXAMPLE_ALSA_IO']:
        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = ['alsa_in.c', '../common/memops.c']
        prog.env.append_value("CFLAGS", "-DNO_JACK_ERROR")
        prog.use = ['clientlib', 'ALSA', 'SAMPLERATE', 'M']
        prog.target = 'alsa_in'

        prog = bld(features = 'c cprogram')
        prog.includes = os_incdir + ['../common/jack', '../common']
        prog.source = ['alsa_out.c', '../common/memops.c']
        prog.env.append_value("CFLAGS", "-DNO_JACK_ERROR")
        prog.use = ['clientlib', 'ALSA', 'SAMPLERATE', 'M']
        prog.target = 'alsa_out'

    for example_lib, example_lib_source in list(example_libs.items()):
        lib = bld(features = 'c cshlib')
        if not bld.env['IS_WINDOWS']:
            lib.env['cshlib_PATTERN'] = '%s.so'
        lib.includes = os_incdir + ['../common/jack', '../common']
        lib.target = example_lib
        lib.source = example_lib_source
        if bld.env['IS_MACOSX']:
            lib.env.append_value("CPPFLAGS", "-mmacosx-version-min=10.4 -arch i386 -arch ppc -arch x86_64")
            #lib.env.append_value("LINKFLAGS", "-arch i386 -arch ppc -arch x86_64")
            lib.env.append_value("LINKFLAGS", "")
        if bld.env['IS_SUN']:
            lib.env.append_value("LINKFLAGS", "-lm")
        lib.use = 'serverlib'
        lib.install_path = '${ADDON_DIR}/'

    if not bld.env['IS_WINDOWS']:
        bld.symlink_as('${PREFIX}/bin/jack_disconnect', 'jack_connect')
        bld.install_files('${PREFIX}/bin', 'jack_control', chmod=0o755)

=== linux/wscript ===
#! /usr/bin/env python
# encoding: utf-8

from waflib import Context

def configure(conf):
    conf.define('HAVE_PPOLL', 1 )

def create_jack_driver_obj(bld, target, sources, uselib = None):
    driver = bld(features = ['c', 'cxx', 'cxxshlib', 'cshlib'])
    driver.env['cxxshlib_PATTERN'] = 'jack_%s.so'

    #driver.defines = ['HAVE_CONFIG_H','SERVER_SIDE', 'HAVE_PPOLL']
    driver.defines = ['HAVE_CONFIG_H','SERVER_SIDE', 'HAVE_PPOLL', 'HAVE_TIMERFD']

    driver.includes = ['.', '../linux', '../posix', '../common', '../common/jack', '../dbus', '../']
    driver.target = target
    driver.source = sources
    driver.install_path = '${ADDON_DIR}/'
    driver.use = []
    if uselib:
        driver.use += uselib
    return driver

def build(bld):
    if bld.env['BUILD_JACKD'] == True:
        jackd = bld(features = ['cxx', 'cxxprogram'])
        jackd.includes = ['../linux', '../posix', '../common/jack', '../common', '../dbus', '../']
        jackd.defines = ['HAVE_CONFIG_H','SERVER_SIDE']
        jackd.source = ['../common/Jackdmp.cpp']
        jackd.use = ['serverlib']
        if bld.env['IS_LINUX'] and bld.env['BUILD_JACKDBUS']:
            jackd.source += ['../dbus/reserve.c', '../dbus/audio_reserve.c']
            jackd.use += ['PTHREAD', 'DL', 'RT', 'M', 'STDC++', 'DBUS-1']
        else:
            jackd.use += ['PTHREAD', 'DL', 'RT', 'M', 'STDC++']
        jackd.target = 'jackd'

    create_jack_driver_obj(bld, 'dummy', '../common/JackDummyDriver.cpp')

    alsa_driver_src = [
                       'alsa/JackAlsaDriver.cpp',
                       'alsa/alsa_rawmidi.c',
                       'alsa/alsa_seqmidi.c',
                       'alsa/alsa_midi_jackmp.cpp',
                       '../common/memops.c',
                       'alsa/generic_hw.c',
                       'alsa/hdsp.c',
                       'alsa/alsa_driver.c',
                       'alsa/hammerfall.c',
                       'alsa/ice1712.c'
                       ]

    alsarawmidi_driver_src = ['alsarawmidi/JackALSARawMidiDriver.cpp',
                              'alsarawmidi/JackALSARawMidiInputPort.cpp',
                              'alsarawmidi/JackALSARawMidiOutputPort.cpp',
                              'alsarawmidi/JackALSARawMidiPort.cpp',
                              'alsarawmidi/JackALSARawMidiReceiveQueue.cpp',
                              'alsarawmidi/JackALSARawMidiSendQueue.cpp',
                              'alsarawmidi/JackALSARawMidiUtil.cpp'
                              ]

    ffado_driver_src = ['firewire/JackFFADODriver.cpp',
                        'firewire/JackFFADOMidiInputPort.cpp',
                        'firewire/JackFFADOMidiOutputPort.cpp',
                        'firewire/JackFFADOMidiReceiveQueue.cpp',
                        'firewire/JackFFADOMidiSendQueue.cpp'
                       ]

    iio_driver_src = ['iio/JackIIODriver.cpp']

    if bld.env['BUILD_DRIVER_ALSA'] == True:
        create_jack_driver_obj(bld, 'alsa', alsa_driver_src, ["ALSA"])
        create_jack_driver_obj(bld, 'alsarawmidi', alsarawmidi_driver_src,
                               ["ALSA"])

    if bld.env['BUILD_DRIVER_FREEBOB'] == True:
        create_jack_driver_obj(bld, 'freebob', 'freebob/JackFreebobDriver.cpp', ["LIBFREEBOB"])

    if bld.env['BUILD_DRIVER_FFADO'] == True:
        create_jack_driver_obj(bld, 'firewire', ffado_driver_src, ["LIBFFADO"])

    if bld.env['BUILD_DRIVER_IIO'] == True:
        create_jack_driver_obj(bld, 'iio', iio_driver_src, ["GTKIOSTREAM", "EIGEN3"])

    create_jack_driver_obj(bld, 'net', '../common/JackNetDriver.cpp')

    create_jack_driver_obj(bld, 'loopback', '../common/JackLoopbackDriver.cpp')

    create_jack_driver_obj(bld, 'netone', [ '../common/JackNetOneDriver.cpp',
                                            '../common/netjack.c',
                                            '../common/netjack_packet.c' ], ["SAMPLERATE", "CELT"])

    create_jack_driver_obj(bld, 'proxy', '../common/JackProxyDriver.cpp')

=== macosx/wscript ===
#! /usr/bin/env python
# encoding: utf-8

def create_jack_driver_obj(bld, target, sources, uselib = None):
    driver = bld.new_task_gen('cxx', 'shlib')
    driver.features.append('cc')
    driver.env['shlib_PATTERN'] = 'jack_%s.so'
    driver.defines = ['HAVE_CONFIG_H','SERVER_SIDE']
    driver.includes = ['.', '../macosx', '../posix', '../common', '../common/jack']
    driver.target = target
    driver.source = sources
    driver.install_path = '${ADDON_DIR}/'
    driver.uselib_local = 'serverlib'
    if uselib:
        driver.uselib = uselib
    return driver

def create_jack_audio_driver_obj(bld, target, sources, uselib = None):
    driver = bld.new_task_gen('cxx', 'shlib')
    driver.features.append('cc')
    driver.env['shlib_PATTERN'] = 'jack_%s.so'
    driver.defines = 'HAVE_CONFIG_H'
    driver.includes = ['.', '../macosx', '../posix', '../common', '../common/jack']
    driver.target = target
    driver.source = sources
    driver.install_path = '${ADDON_DIR}/'
    driver.uselib_local = 'serverlib'
    driver.env.append_value("LINKFLAGS", "-framework CoreAudio -framework CoreServices -framework AudioUnit")
    if uselib:
        driver.uselib = uselib
    return driver

def create_jack_midi_driver_obj(bld, target, sources, uselib = None):
    driver = bld.new_task_gen('cxx', 'shlib')
    driver.features.append('cc')
    driver.env['shlib_PATTERN'] = 'jack_%s.so'
    driver.defines = 'HAVE_CONFIG_H'
    driver.includes = ['.', '../macosx', '../posix', '../common', '../common/jack']
    driver.target = target
    driver.source = sources
    driver.install_path = '${ADDON_DIR}/'
    driver.uselib_local = 'serverlib'
    driver.env.append_value("LINKFLAGS", "-framework CoreMIDI -framework CoreServices -framework AudioUnit")
    if uselib:
        driver.uselib = uselib
    return driver

def build(bld):
    if bld.env['BUILD_JACKD'] == True:
    	jackd = bld.new_task_gen('cxx', 'program')
    	jackd.includes = ['.', '../macosx', '../posix', '../common', '../common/jack']
    	jackd.defines = 'HAVE_CONFIG_H'
    	jackd.source = ['../common/Jackdmp.cpp']
    	jackd.uselib = 'PTHREAD DL'
    	jackd.uselib_local = 'serverlib'
    	jackd.env.append_value("LINKFLAGS", "-framework CoreFoundation")
    	jackd.target = 'jackd'

    create_jack_driver_obj(bld, 'dummy', '../common/JackDummyDriver.cpp')

    create_jack_driver_obj(bld, 'loopback', '../common/JackLoopbackDriver.cpp')

    create_jack_audio_driver_obj(bld, 'coreaudio', 'coreaudio/JackCoreAudioDriver.cpp')

    create_jack_midi_driver_obj(
        bld,
        'coremidi',
        ['coremidi/JackCoreMidiInputPort.cpp',
         'coremidi/JackCoreMidiOutputPort.cpp',
         'coremidi/JackCoreMidiPhysicalInputPort.cpp',
         'coremidi/JackCoreMidiPhysicalOutputPort.cpp',
         'coremidi/JackCoreMidiVirtualInputPort.cpp',
         'coremidi/JackCoreMidiVirtualOutputPort.cpp',
         'coremidi/JackCoreMidiPort.cpp',
         'coremidi/JackCoreMidiUtil.cpp',
         'coremidi/JackCoreMidiDriver.cpp'])
    
    portaudio_src = [
        '../windows/JackPortAudioDriver.cpp',
        '../windows/JackPortAudioDevices.cpp',
    	]

    #create_jack_audio_driver_obj(bld, 'portaudio', portaudio_src)

    create_jack_driver_obj(bld, 'net', '../common/JackNetDriver.cpp')

    create_jack_driver_obj(bld, 'netone', [ '../common/JackNetOneDriver.cpp',
		                            '../common/netjack.c',
					    '../common/netjack_packet.c' ], "SAMPLERATE CELT" )

    create_jack_driver_obj(bld, 'proxy', '../common/JackProxyDriver.cpp')

=== man/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import re
import os


def build(bld):
    bld.exec_command("cd man ; sh fill_template %s" % bld.env['JACK_VERSION'])
    bld.install_files(bld.env['MANDIR'], bld.path.ant_glob('*.1'))

=== solaris/wscript ===
#! /usr/bin/env python
# encoding: utf-8

def create_jack_driver_obj(bld, target, sources, uselib = None):
    driver = bld.new_task_gen('cxx', 'shlib')
    driver.features.append('cc')
    driver.env['shlib_PATTERN'] = 'jack_%s.so'
    #driver.env.append_unique('CXXFLAGS', '-march=i686 -msse3 -ffast-math')
    #driver.env.append_unique('CFLAGS', '-march=i686  -msse3  -ffast-math')
    driver.defines = 'HAVE_CONFIG_H'
    driver.includes = ['.', '..','../posix', '../common', '../common/jack']
    driver.target = target
    driver.source = sources
    driver.install_path = '${ADDON_DIR}/'
    driver.uselib_local = 'serverlib'
    if uselib:
        driver.uselib = uselib
    return driver

def build(bld):
    jackd = bld.new_task_gen('cxx', 'program')
    jackd.includes = ['.','..', '../posix', '../common/jack', '../common']
    jackd.defines = 'HAVE_CONFIG_H'
    jackd.source = ['../common/Jackdmp.cpp']
    jackd.uselib = 'PTHREAD DL'
    jackd.uselib_local = 'serverlib'
    jackd.target = 'jackd'

    create_jack_driver_obj(bld, 'oss', ['oss/JackOSSDriver.cpp', '../common/memops.c'])

    create_jack_driver_obj(bld, 'boomer', ['oss/JackBoomerDriver.cpp', '../common/memops.c'])

    create_jack_driver_obj(bld, 'dummy', '../common/JackDummyDriver.cpp')

    create_jack_driver_obj(bld, 'net', '../common/JackNetDriver.cpp')

    create_jack_driver_obj(bld, 'loopback', '../common/JackLoopbackDriver.cpp')

    create_jack_driver_obj(bld, 'proxy', '../common/JackProxyDriver.cpp')

=== windows/wscript ===
#! /usr/bin/env python
# encoding: utf-8

def create_jack_driver_obj(bld, target, sources, uselib = None):
    driver = bld(features = ['c', 'cxx', 'cxxshlib', 'cshlib'])
    driver.env['cxxshlib_PATTERN'] = 'jack_%s.dll'
    driver.defines = ['HAVE_CONFIG_H','SERVER_SIDE']
    driver.includes = ['.', '..' , '../windows', '../common', '../common/jack']
    driver.target = target
    driver.source = sources
    driver.install_path = '${ADDON_DIR}/'
    driver.use = ['serverlib']
    if uselib:
        driver.use += uselib
    return driver

def build(bld):
    if bld.env['BUILD_JACKD'] == True:
        jackd = bld(features = ['cxx', 'cxxprogram'])
        jackd.includes = ['..', '../windows', '../common/jack', '../common', '../dbus']
        jackd.defines = ['HAVE_CONFIG_H','SERVER_SIDE']
        jackd.source = ['../common/Jackdmp.cpp']
        jackd.install_path = '${BINDIR}'
        jackd.use = ['serverlib']
        jackd.target = 'jackd'

    create_jack_driver_obj(bld, 'dummy', '../common/JackDummyDriver.cpp')

    winmme_driver_src = [
                       'winmme/JackWinMMEDriver.cpp',
                       'winmme/JackWinMMEInputPort.cpp',
                       'winmme/JackWinMMEOutputPort.cpp',
                       'winmme/JackWinMMEPort.cpp',
                       ]

    if bld.env['BUILD_DRIVER_WINMME'] == True:
        winmme_driver = bld(features = ['c', 'cxx', 'cxxshlib', 'cshlib'])
        winmme_driver.env['cxxshlib_PATTERN'] = 'jack_%s.dll'
        winmme_driver.defines = ['HAVE_CONFIG_H','SERVER_SIDE']
        winmme_driver.includes = ['.', '..' , '../windows', '../common', '../common/jack']
        winmme_driver.target = 'winmme'
        winmme_driver.source = winmme_driver_src
        winmme_driver.install_path = '${ADDON_DIR}/'
        winmme_driver.use = ['serverlib', 'WINMME']

    portaudio_driver_src = [
                       'portaudio/JackPortAudioDevices.cpp',
                       'portaudio/JackPortAudioDriver.cpp',
                       ]

    if bld.env['BUILD_DRIVER_PORTAUDIO'] == True:
        portaudio_driver = bld(features = ['c', 'cxx', 'cxxshlib', 'cshlib'])
        portaudio_driver.env['cxxshlib_PATTERN'] = 'jack_%s.dll'
        portaudio_driver.defines = ['HAVE_CONFIG_H','SERVER_SIDE']
        portaudio_driver.includes = ['.', '..' , '../windows', '../common', '../common/jack']
        portaudio_driver.target = 'portaudio'
        portaudio_driver.source = portaudio_driver_src
        portaudio_driver.install_path = '${ADDON_DIR}/'
        portaudio_driver.use = ['serverlib', 'PORTAUDIO' ]

    create_jack_driver_obj(bld, 'net', '../common/JackNetDriver.cpp')

    create_jack_driver_obj(bld, 'loopback', '../common/JackLoopbackDriver.cpp')

    create_jack_driver_obj(bld, 'netone', [ '../common/JackNetOneDriver.cpp',
                                            '../common/netjack.c',
                                            '../common/netjack_packet.c' ], ["SAMPLERATE", "CELT"] )

    create_jack_driver_obj(bld, 'proxy', '../common/JackProxyDriver.cpp')

=== debian/changelog ===
jackd2 (1.9.10+20150825git1ed50c92~dfsg-5ubuntu1) artful; urgency=medium

  * Merge with Debian; remaining changes:
    - libjacknet strict shlibs that don't claim compatibility with anything
      but the current version of the package.
  * Fix FTBFS with GCC 7.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 11 Oct 2017 10:09:40 +0200

jackd2 (1.9.10+20150825git1ed50c92~dfsg-5) unstable; urgency=medium

  * Move libjackserver into package libjack-jackd2-0.  This avoids a
    dangling symbolic link in the package libjack-jackd2-dev.
    (Closes: #858525)

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 27 Mar 2017 22:44:11 -0400

jackd2 (1.9.10+20150825git1ed50c92~dfsg-4) unstable; urgency=medium

  * Team upload.
  * Tighten generated dependencies for new jack_port_rename api.
    (Closes: #835589, #845655)
  * Fix manual debhelper dependency in d/control.
  * Fix FTBFS with DEB_BUILD_PARALLEL=1. (Closes: #766993)
    Thanks to YunQiang Su.
  * Drop libjack-jackd2-dev dependency on libdbus-1-dev. (Closes: #799977)

 -- James Cowgill <jcowgill@debian.org>  Sun, 04 Dec 2016 11:25:01 +0000

jackd2 (1.9.10+20150825git1ed50c92~dfsg-3) unstable; urgency=medium

  * Team upload.
  * Fix bus errors ARM, MIPS and PowerPC due to use of packed structs.
    (Closes: #728710)

 -- James Cowgill <jcowgill@debian.org>  Wed, 19 Oct 2016 10:29:38 +0000

jackd2 (1.9.10+20150825git1ed50c92~dfsg-2ubuntu2) yakkety; urgency=medium

  * No-change rebuild for readline soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 17 Sep 2016 12:04:38 +0000

jackd2 (1.9.10+20150825git1ed50c92~dfsg-2ubuntu1) yakkety; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - libjacknet strict shlibs that don't claim compatibility with anything
      but the current version of the package.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 27 Jul 2016 15:13:51 +0200

jackd2 (1.9.10+20150825git1ed50c92~dfsg-2) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with gcc 6. Closes: #811720

 -- Felipe Sateler <fsateler@debian.org>  Sun, 24 Jul 2016 23:18:31 -0400

jackd2 (1.9.10+20150825git1ed50c92~dfsg-1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - libjacknet strict shlibs that don't claim compatibility with anything
      but the current version of the package.
  * Dropped changes:
    - conflicts/replaces against the reverted g++5 package name, no longer
      needed after wily release.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Oct 2015 16:34:25 -0700

jackd2 (1.9.10+20150825git1ed50c92~dfsg-1) unstable; urgency=low

  * Make builds reproducible (Closes: #796807)
  * Imported Upstream version 1.9.10+20150825git1ed50c92~dfsg

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Tue, 25 Aug 2015 17:13:51 +0200

=== debian/control ===
Source: jackd2
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Adrian Knoth <adi@drcomp.erfurt.thur.de>, Jonas Smedegaard <dr@jones.dk>, Reinhard Tartler <siretart@tauware.de>
Build-Depends: cdbs (>= 0.4.93~),
 debhelper (>= 9),
 d-shlibs,
 python (>= 2.6.6-3~),
 libsamplerate-dev,
 libasound2-dev (>= 1.0.18) [linux-any],
 libdbus-1-dev,
 libexpat1-dev,
 libsndfile1-dev,
 libncurses-dev,
 libreadline-dev,
 libraw1394-dev [linux-any],
 libffado-dev (>= 2.0.0) [linux-any],
 libopus-dev,
 po-debconf
Standards-Version: 3.9.6
Homepage: http://jackaudio.org/
Vcs-Git: git://git.debian.org/git/pkg-multimedia/jackd2.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/jackd2.git

Package: jackd2
Architecture: any
Replaces: libjack0 (<= 1.9.5~dfsg-13),
	jackd (<< 3),
	jack-daemon
Provides: jack-daemon
Conflicts: jack-daemon,
	jackd (<< 3)
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${python:Depends},
 coreutils (>= 4.0),
 python-dbus,
 debconf | debconf-2.0,
 libjack-jackd2-0 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Recommends: qjackctl,
 libpam-modules,
 jackd2-firewire [amd64 i386 powerpc]
Suggests: jack-tools,
 meterbridge
Description: JACK Audio Connection Kit (server and example clients)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the daemon jackd as well as some example clients.

Package: libjack-jackd2-0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
 ${misc:Depends}
Conflicts: jackd2 (>> ${binary:Version}),
 jackd2 (<< ${binary:Version}),
 libjack0,
 libjack-0.116,
 libjack-0.125
Suggests: jackd2 (= ${binary:Version})
Provides: libjack-0.116, libjack-0.125
Replaces: libjack-0.116, libjack-0.125, jackd2 (<< 1.9.10+20150825git1ed50c92~dfsg-5)
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: JACK Audio Connection Kit (libraries)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the shared libraries.

Package: jackd2-firewire
Architecture: amd64 i386 powerpc
Provides: jackd-firewire
Replaces: jackd-firewire
Conflicts: jackd-firewire
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
 ${misc:Depends},
 jackd2 (= ${binary:Version})
Description: JACK Audio Connection Kit (FFADO and FreeBoB backends)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains the IEEE1394 (FireWire) backends FFADO and FreeBoB.

Package: libjack-jackd2-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libjack-jackd2-0 (= ${binary:Version}), 
 ${asound:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
 pkg-config
Conflicts: libjack0.100.0-dev (<< 0.102.20-2),
 libjack-dev
Provides: libjack0.100.0-dev,
 libjack-dev-session,
 libjack-dev
Replaces: libjack0.71.2-0 (<< 0.75.0-1)
Description: JACK Audio Connection Kit (development files)
 JACK is a low-latency sound server, allowing multiple applications to
 connect to one audio device, and to share audio between themselves.
 .
 This package contains files needed for the development of JACK applications
 and an API reference.

=== debian/rules ===
#!/usr/bin/make -f

# Let's try to cut down noisy symbols to the official API
export DEB_CFLAGS_MAINT_APPEND = -fvisibility=hidden
export DEB_CXXFLAGS_MAINT_APPEND = -fvisibility=hidden

-include /usr/share/cdbs/1/rules/upstream-tarball.mk
-include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

# suppress optional build-dependencies
CDBS_BUILD_DEPENDS_rules_upstream-tarball =
CDBS_BUILD_DEPENDS_rules_utils_copyright-check =

# Explicitly require these versions until cdbs knows about multiarch
CDBS_BUILD_DEPENDS += , cdbs (>= 0.4.93~), debhelper (>= 9)
CDBS_BUILD_DEPENDS_rules_debhelper_buildinfo =

# Set tag to full 40 char git tag for git snapshot release
tag = $(DEB_UPSTREAM_TARBALL_VERSION)
DEB_UPSTREAM_URL = https://github.com/jackaudio/jack2/archive
DEB_UPSTREAM_TARBALL_BASENAME = $(tag)
DEB_UPSTREAM_TARBALL_SRCDIR = jack2-$(tag)

# unneeded and possibly sourceless binaries
DEB_UPSTREAM_REPACKAGE_EXCLUDES += *.a *.dll *.Lib

# unneeded sources copyright-protected without licence
DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./windows/**.rc

# pure garbage in upstream tarball
DEB_UPSTREAM_REPACKAGE_EXCLUDES += .DS_Store

# Minimum assured version referenced upstream as library API/ABI
ABI = 0.118.0

WAF_EXTRA_ARGS = $(filter-out -j%,$(DEB_MAKE_EXTRA_ARGS))

waf-configure-options = --prefix=/usr --classic
waf-configure-options += --libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
waf-configure-options += $(if $(filter linux,$(DEB_HOST_ARCH_OS)),--alsa --dbus)
waf-configure-options += $(if $(filter amd64 i386 powerpc,$(DEB_HOST_ARCH)),--firewire)

DEB_MAKE_INVOKE = $(WAF_EXTRA_ARGS) ./waf -v --destdir=$(CURDIR)/debian/tmp
DEB_MAKE_INSTALL_TARGET = install

# TODO: use distclean and drop related clean target, when (or if)
# upstream stop shipping waf dir
DEB_MAKE_CLEAN_TARGET = clean
clean::
	rm -f .lock-wscript .lock-waf_linux2_build
	find waflib -name "*.pyc" -delete || true
	rm -f man/*.1
	rm -rf build

DEB_DH_MAKESHLIBS_ARGS = -Xintime -Xinprocess -Xjack_alsa -Xjack_oss -Xjack_dummy -Xjack_firewire

# too noisy symbols, so only watch disappearing ones for now
DEB_DH_MAKESHLIBS_ARGS += -- -c1

# Generate (and cleanup) files containing variables static per build
infiles = $(filter-out debian/control.in, $(wildcard debian/*.in))
outfiles = $(basename $(infiles))
DEB_PHONY_RULES += $(outfiles)
pre-build:: $(outfiles)
$(outfiles): update-config debian/stamp-copyright-check
	sed 's/__ABI__/$(ABI)/; s/$${DEB_VERSION}/${DEB_VERSION}/g' <$@.in >$@
clean::
	rm -f $(outfiles)

common-configure-arch common-configure-indep:: common-configure-impl
common-configure-impl:: debian/stamp-waf-configure
debian/stamp-waf-configure:
	$(WAF_EXTRA_ARGS) ./waf configure $(waf-configure-options) $(DEB_MAKE_PARALLEL)
	touch $@
clean::
	rm -f debian/stamp-waf-configure

install/jackd2::
ifeq ($(DEB_HOST_ARCH_OS),linux)
	dh_install -pjackd2 debian/tmp/usr/bin/alsa_in
	dh_install -pjackd2 debian/tmp/usr/bin/alsa_out
	dh_install -pjackd2 debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/jack/jack_alsa.so
	dh_install -pjackd2 debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/jack/jack_alsarawmidi.so
	dh_install -pjackd2 debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/jack/audioadapter.so
	dh_install -pjackd2 debian/tmp/usr/share/dbus-1/*
endif	

binary-install/jackd2::
	dh_python2 -pjackd2

# TODO: drop libstdc++6 override when bug#374049 closed in stable
binary-post-install/libjack0::
	d-devlibdeps \
		--override s/libjackserver0-dev// \
		--override s/libffado2-dev/libffado-dev/ \
		--override s/libcelt0-0-dev/libcelt-dev/ \
		--override s/libstdc++6-4.1-dev// \
		debian/libjack-dev.substvars \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.so \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/jack/*.so

#common-binary-post-install-arch::
#        ln -s jackdmp debian/jackdmp/usr/bin/jackd
